package asCode
{
   import com.terry.Broadcaster;
   import com.terry.GeneralEvents;
   import flash.display.*;
   import flash.events.*;
   import flash.text.*;
   
   public class MainMenuClipClass extends MovieClip
   {
      public var playFacebookBtn:playOnFaceBookBtn;
      
      public var effectHolder:MovieClip;
      
      public var embedGameBtn:embedBtnClip;
      
      public var mainNav:MovieClip;
      
      public var eye1:MovieClip;
      
      public var eye2:MovieClip;
      
      private var snowBitmapData:BitmapData;
      
      private var snowBitmap:Bitmap;
      
      private var facebookStatus:String = "no";
      
      private var snowActive:Boolean = false;
      
      private var particleManagerRef:particleManagerClass;
      
      private var languageFrame:String;
      
      public function MainMenuClipClass()
      {
         super();
         Broadcaster.addEventListener(GeneralEvents.STOP_SNOW,stopSnow);
         Broadcaster.addEventListener(GeneralEvents.START_SNOW,startSnow);
         Broadcaster.addEventListener(GeneralEvents.RECEIVE_FACEBOOK,receiveFaceData);
      }
      
      public function init(param1:BitmapData) : void
      {
         snowBitmapData = new BitmapData(480,200,true,255);
         snowBitmap = new Bitmap(snowBitmapData);
         addEventListener(Event.ENTER_FRAME,snowLoop);
         this.effectHolder.addChild(snowBitmap);
         snowBitmap.y = -5;
         this.effectHolder.mouseEnabled = false;
         particleManagerRef = new particleManagerClass(snowBitmapData,param1);
         mainNav.viewHighscoreBtn.visible = false;
         mainNav.stfBtn.visible = false;
         mainNav.sendToValentineBtn.visible = false;
         embedGameBtn.visible = false;
         playFacebookBtn.visible = false;
      }
      
      private function stopSnow(param1:GeneralEvents) : void
      {
         snowActive = false;
      }
      
      private function startSnow(param1:GeneralEvents) : void
      {
         snowActive = true;
         Debug.log("trying to get facebook status = " + facebookStatus);
         var _loc2_:Object = new Object();
         _loc2_.clip = this;
         Broadcaster.dispatchEvent(new GeneralEvents(GeneralEvents.GET_LANGUAGE_FACEBOOK_STATUS,true,_loc2_));
      }
      
      private function receiveFaceData(param1:*) : void
      {
         facebookStatus = param1.data.facebookStatus;
         Debug.log("facebookStatus = " + facebookStatus);
         if(facebookStatus == "yes")
         {
            playFacebookBtn.visible = false;
         }
         else
         {
            playFacebookBtn.visible = false;
         }
         languageFrame = String(param1.data.languageFrame);
         if(languageFrame == "jp" || languageFrame == "ko" || languageFrame == "ru" || languageFrame == "cn" || languageFrame == "la" || languageFrame == "pt")
         {
            mainNav.stfBtn.visible = false;
         }
      }
      
      private function snowLoop(param1:Event) : void
      {
         if(snowActive)
         {
            snowBitmapData.fillRect(snowBitmapData.rect,65280);
            if(Math.random() < 0.3)
            {
               particleManagerRef.createParticles(Math.random() * 480,0,1,12);
            }
            particleManagerRef.manageParticles(0);
            if(Math.random() * 1000 < 15)
            {
               this.eye1.gotoAndPlay(1);
               this.eye2.gotoAndPlay(1);
            }
         }
      }
   }
}

